]> git.madduck.net Git - code/vcsh.git/commitdiff

madduck's git repository

Every one of the projects in this repository is available at the canonical URL git://git.madduck.net/madduck/pub/<projectpath> — see each project's metadata for the exact URL.

All patches and comments are welcome. Please squash your changes to logical commits before using git-format-patch and git-send-email to patches@git.madduck.net. If you'd read over the Git project's submission guidelines and adhered to them, I'd be especially grateful.

SSH access, as well as push access can be individually arranged.

If you use my repositories frequently, consider adding the following snippet to ~/.gitconfig and using the third clone URL listed for each project:

[url "git://git.madduck.net/madduck/"]
  insteadOf = madduck:

Made fully(?) POSIX shell compliant, some minor cleanups
authorRichard Hartmann <richih.mailinglist@gmail.com>
Sat, 17 Sep 2011 23:20:02 +0000 (01:20 +0200)
committerRichard Hartmann <richih.mailinglist@gmail.com>
Sat, 17 Sep 2011 23:20:02 +0000 (01:20 +0200)
* This version should be fully POSIX shell compliant
* Quoted all variables withing [ ]
* Added debugging and verbose output via shell variables
* Cleaned up INSTALL

INSTALL
vcsh

diff --git a/INSTALL b/INSTALL
index 5813f809e7ee99753492087757823606939f7011..897c5ebc111f1a7969a56b0805f3c6de6a30b451 100644 (file)
--- a/INSTALL
+++ b/INSTALL
@@ -5,19 +5,19 @@ mkdir -p ~/work/git
 cd !$
 
 # Clone vcsh and make it available
 cd !$
 
 # Clone vcsh and make it available
-git clone git://github.com/RichiH/vcsh.git vcsh-readonly
-PATH+=":/home/richih/work/git/vcsh-readonly"
+git clone git://github.com/RichiH/vcsh.git vcsh
+PATH+=":$HOME/work/git/vcsh"
 export PATH
 
 # Grab my mr config. see below for details on how I set this up
 export PATH
 
 # Grab my mr config. see below for details on how I set this up
-zsh ~/work/git/vcsh-readonly/vcsh clone ssh://<remote>/mr.git
+~/work/git/vcsh/vcsh clone ssh://<remote>/mr.git
 cd ~/.config/mr/config.d/
 ln -s ../available.d/* .
 
 # make vcsh work by default. Adapt for Bash etc as needed
 cd
 cd ~/.config/mr/config.d/
 ln -s ../available.d/* .
 
 # make vcsh work by default. Adapt for Bash etc as needed
 cd
-zsh ~/work/git/vcsh-readonly/vcsh clone ssh://<remote>/zsh.git
-ln -s ~/work/git/vcsh-readonly/vcsh .zsh/functions
+zsh ~/work/git/vcsh/vcsh clone ssh://<remote>/zsh.git
+ln -s ~/work/git/vcsh/vcsh .zsh/functions
 zsh
 
 
 zsh
 
 
diff --git a/vcsh b/vcsh
index c4423fdb1ae72fd8b27166643d1bd9ea98731f7b..eb852a01aa9103fc4b4b1e953d2c67e20174a290 100755 (executable)
--- a/vcsh
+++ b/vcsh
@@ -1,14 +1,14 @@
 #!/bin/sh
 
 #!/bin/sh
 
-#set -x
+[ "$VCSH_DEBUG" -gt 0 ] && set -x
 
 SELF=$(basename $0)
 
 
 SELF=$(basename $0)
 
-[ -z $XDG_CONFIG_HOME ] && XDG_CONFIG_HOME="$HOME/.config"
+[ -z "$XDG_CONFIG_HOME" ] && XDG_CONFIG_HOME="$HOME/.config"
 for check_directory in $XDG_CONFIG_HOME $XDG_CONFIG_HOME/vcsh $XDG_CONFIG_HOME/vcsh/repo.d
 do
 for check_directory in $XDG_CONFIG_HOME $XDG_CONFIG_HOME/vcsh $XDG_CONFIG_HOME/vcsh/repo.d
 do
-       if [ ! -d $check_directory ]; then
-               if [ -e $check_directory ]; then
+       if [ ! -d "$check_directory" ]; then
+               if [ -e "$check_directory" ]; then
                        echo "$SELF: error: $check_directory exists but is not a directory" >&2
                        exit 2
                else
                        echo "$SELF: error: $check_directory exists but is not a directory" >&2
                        exit 2
                else
@@ -19,6 +19,14 @@ done
 
 VCSH_BASE="$XDG_CONFIG_HOME/vcsh/repo.d"
 
 
 VCSH_BASE="$XDG_CONFIG_HOME/vcsh/repo.d"
 
+debug() {
+       [ -n "$VCSH_DEBUG" ] && echo "$SELF: debug: $1"
+}
+
+verbose() {
+       if [ -n "$VCSH_DEBUG" ] || [ -n "$VCSH_VERBOSE" ]; then echo "$SELF: verbose: $1"; fi
+}
+
 help() {
        echo "usage: $SELF <args>
 
 help() {
        echo "usage: $SELF <args>
 
@@ -38,6 +46,7 @@ help() {
 }
 
 use() {
 }
 
 use() {
+       verbose "use() start"
        REPO_NAME="$1"
        GIT_DIR="$VCSH_BASE/$REPO_NAME.git"
 
        REPO_NAME="$1"
        GIT_DIR="$VCSH_BASE/$REPO_NAME.git"
 
@@ -49,10 +58,12 @@ use() {
        export GIT_DIR
        export GIT_WORK_TREE="$(git config --get core.worktree)"
        export VCSH_DIRECTORY="$REPO_NAME"
        export GIT_DIR
        export GIT_WORK_TREE="$(git config --get core.worktree)"
        export VCSH_DIRECTORY="$REPO_NAME"
+       verbose "use() stop"
 }
 
 init() {
 }
 
 init() {
-       [[ -e $GIT_DIR ]] &&
+       verbose "init() start"
+       [ -e "$GIT_DIR" ] &&
                echo "$SELF: fatal: $GIT_DIR exists" &&
                return 21
        export GIT_WORK_TREE="$HOME"
                echo "$SELF: fatal: $GIT_DIR exists" &&
                return 21
        export GIT_WORK_TREE="$HOME"
@@ -63,6 +74,7 @@ init() {
        cd $GIT_WORK_TREE
        git init
        git config core.worktree $GIT_WORK_TREE
        cd $GIT_WORK_TREE
        git init
        git config core.worktree $GIT_WORK_TREE
+       verbose "init() stop"
 }
 
 leave() {
 }
 
 leave() {
@@ -71,45 +83,52 @@ leave() {
        unset VCSH_DIRECTORY
 }
 
        unset VCSH_DIRECTORY
 }
 
-if [ "$1" = 'help' ] || [ $# -eq 0 ]; then
+if [ "$1" = 'help' ] || [ "$#" -eq 0 ]; then
        help
        [ "$1" = 'help' ]
        exit $?
 
 elif [ "$1" = 'list' ]; then
        help
        [ "$1" = 'help' ]
        exit $?
 
 elif [ "$1" = 'list' ]; then
+       verbose "list start"
        for i in $VCSH_BASE/*.git; do
                echo $(basename $i .git)
        done
        for i in $VCSH_BASE/*.git; do
                echo $(basename $i .git)
        done
+       verbose "list stop"
        exit 0
 
 elif [ "$1" = 'run' ]; then
        exit 0
 
 elif [ "$1" = 'run' ]; then
+       verbose "run start"
        use $2
        shift 2
        "$@"
        leave
        use $2
        shift 2
        "$@"
        leave
+       verbose "run start"
        exit 0
 
 elif [ "$1" = 'use' ]; then
        exit 0
 
 elif [ "$1" = 'use' ]; then
-       if [[ -o NO_IGNORE_EOF ]]; then
-               export VCSH_NO_IGNORE_EOF=1
-               setopt IGNORE_EOF
-               if [[ -n $ZSH_VERSION ]]; then
-                       vcsh_exit() {
-                               vcsh exit;
-                               zle reset-prompt;
-                       }
+       verbose "use start"
+       if [ -n "$ZSH_VERSION" ]; then
+               if [ -o NO_IGNORE_EOF ]; then
+                       export VCSH_NO_IGNORE_EOF=1
+                       setopt IGNORE_EOF
                fi
                fi
+               vcsh_exit() {
+                       vcsh exit;
+                       zle reset-prompt;
+               }
                zle -N vcsh_exit
                bindkey '^d' 'vcsh_exit'
        fi
        use $2
                zle -N vcsh_exit
                bindkey '^d' 'vcsh_exit'
        fi
        use $2
-       buildPS1
+       [ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
+       verbose "use stop"
        exit 0
 
 elif [ "$1" = 'clone' ]; then
        exit 0
 
 elif [ "$1" = 'clone' ]; then
+       verbose "clone start"
        GIT_REMOTE="$2"
        REPO_NAME="$3"
        GIT_REMOTE="$2"
        REPO_NAME="$3"
-       [[ -z $REPO_NAME ]] && REPO_NAME=$(basename $GIT_REMOTE .git)
+       [ -z "$REPO_NAME" ] && REPO_NAME=$(basename $GIT_REMOTE .git)
        export REPO_NAME
        export GIT_DIR="$VCSH_BASE/$REPO_NAME.git"
        init
        export REPO_NAME
        export GIT_DIR="$VCSH_BASE/$REPO_NAME.git"
        init
@@ -118,33 +137,39 @@ elif [ "$1" = 'clone' ]; then
        git config branch.master.remote origin
        git config branch.master.merge  refs/heads/master
        git fetch
        git config branch.master.remote origin
        git config branch.master.merge  refs/heads/master
        git fetch
-       for i in $(git ls-tree -r origin/master | awk '{print $4}'); do
-       [[ -e $i ]] &&
-               echo "$SELF: error: $i exists." &&
-               CONFLICT=1;
+       for object in $(git ls-tree -r origin/master | awk '{print $4}'); do
+               [ -e "$object" ] &&
+                       echo "$SELF: error: $object exists." &&
+                       VCSH_CONFLICT=1;
        done
        done
-       [[ -n $CONFLICT ]] &&
+       [ -n "$VCSH_CONFLICT" ] &&
                echo "$SELF: fatal: will stop after fetching and not try to merge!\n" &&
                exit 3
        git merge origin/master
        vcsh use $REPO_NAME
                echo "$SELF: fatal: will stop after fetching and not try to merge!\n" &&
                exit 3
        git merge origin/master
        vcsh use $REPO_NAME
+       verbose "clone end"
 
 elif [ "$1" = 'init' ]; then
 
 elif [ "$1" = 'init' ]; then
+       verbose "init start"
        export REPO_NAME="$2"
        export GIT_DIR="$VCSH_BASE/$REPO_NAME.git"
        init
        vcsh use $REPO_NAME
        export REPO_NAME="$2"
        export GIT_DIR="$VCSH_BASE/$REPO_NAME.git"
        init
        vcsh use $REPO_NAME
+       verbose "init stop"
 
 elif [ "$1" = 'exit' ]; then
 
 elif [ "$1" = 'exit' ]; then
-       if [[ $VCSH_NO_IGNORE_EOF -gt 0 ]]; then
+       verbose "exit start"
+       if [ -n "$ZSH_VERSION" ] && [ -n "$VCSH_NO_IGNORE_EOF" ]; then
                unset VCSH_NO_IGNORE_EOF
                setopt NO_IGNORE_EOF
        fi
        leave
                unset VCSH_NO_IGNORE_EOF
                setopt NO_IGNORE_EOF
        fi
        leave
-       buildPS1
+       [ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
+       verbose "exit stop"
        exit 0
 
 else
        exit 0
 
 else
+       verbose "defaulting to calling help()"
        help
        exit 3
 
        help
        exit 3